#! /usr/bin/perl

# You can use a "require" to pull this into another Perl program, like this:
#
#   @INC = (".");
#   print "before 'require splitcsv.pl'";
#   require ".\\splitcsv.pl";
#   print "after 'require splitcsv.pl'";



# split a CSV record into fields, return the array of fields
sub split_csv {
  local(@fields);
  local($inp) = @_;
  local($fieldnum) = 0;
  local($field,$ndx);

  while (1) {
     $fieldnum++;
     $field = '';
     if ('"' eq substr($inp,0,1)) {
        #quoted field
        $inp = substr($inp,1);  #discard leading quote
        ($field,$inp) = split('"',$inp,2);
        if (!defined $inp) {
           # no terminating quote mark
           $inp = '';
        }
     } else {
        #unquoted field
        $ndx = index($inp,',');
        if ($ndx >= 0) {
           # found a comma
           $field = substr($inp,0,$ndx);
           $inp = substr($inp,$ndx);
        } else {
           # no more commas, so this must be last field
           $field = $inp;
           $inp = '';
        }
     }
     push(@fields,$field);
     if ($inp eq '') {
        last;
     }
     if (',' eq substr($inp,0,1)) {
        $inp = substr($inp,1);  # discard comma
     } else {
        print STDERR "ERROR: record $. has quote mark within quoted field $fieldnum, or is missing a comma.\n";
        print STDERR "Rest of record is: '$inp'\n";
     }
  } #while
  return @fields;
} #split_csv

# return true value to 'require'
1;
